﻿Imports System.Net, System.Net.Sockets, System.IO, System.Threading
Imports System.Text
Imports System.Text.RegularExpressions

Module Module1

    Dim dnsserv, s As Socket

    Dim defColor As ConsoleColor = Console.ForegroundColor

    Dim fake_ip As String = ""

    Dim mustLog As Boolean = False
    Dim log As String = "logDNS.log"

    'DNS server to use to resolve hostnames :
    'Const DEFAULT_DNS_SERVER As String = "10.4.1.79"
    'Const DEFAULT_DNS_SERVER As String = "4.2.2.2"
    Const DEFAULT_DNS_SERVER As String = "208.67.222.222"

    Private Function IsIP(ByVal ip As String) As Boolean
        Dim rIP As Regex = New Regex("^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$")
        Return rIP.IsMatch(ip)
    End Function

    Sub Main(ByVal args As String())

        If args.Length() > 0 Then
            If args.Length() > 1 Then
                Console.WriteLine("Too many parameters ! Using the first one as the IP of the fake GTS server.")
                Console.WriteLine()
            End If

            fake_ip = args(0)
        End If

        Do Until IsIP(fake_ip)
            If fake_ip <> "" Then
                Console.WriteLine("This is not a valid IP address !")
            End If

            Console.Write("Please enter the IP of the fake GTS server : ")
            fake_ip = Console.ReadLine()
        Loop
        Console.WriteLine()


        Dim thr As Thread = New Thread(AddressOf dnsspoof)
        thr.Start()
    End Sub


    Private Sub dnsspoof()
        dnsserv = New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
        dnsserv.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, 1)

        dnsserv.Bind(New IPEndPoint(IPAddress.Any, 53))

        Console.Write("DNS server started on ")
        Console.ForegroundColor = ConsoleColor.Blue
        Console.WriteLine(CType(dnsserv.LocalEndPoint, IPEndPoint).ToString)
        Console.ForegroundColor = defColor
        Console.WriteLine()

        If mustLog AndAlso File.Exists(log) AndAlso File.ReadAllBytes(log).Length > 0 Then
            File.AppendAllText(log, "----------------------------------------" & vbCrLf & vbCrLf)
        End If

        If mustLog Then File.AppendAllText(log, "DNS server started on " & CType(dnsserv.LocalEndPoint, IPEndPoint).ToString & vbCrLf & vbCrLf)

        Dim fake_ip_byte(3) As Byte
        For i = 0 To 3
            fake_ip_byte(i) = CInt(fake_ip.Split(".")(i))
        Next

        Dim r(511), rr(511) As Byte ', rr_fake(511)
        Dim lngSnd, lngRcv As Integer
        Dim str_r, str_rr, host As String

        Dim rem_ep As EndPoint = New IPEndPoint(IPAddress.Any, 0)

        While True
            Try
                ReDim r(511)

                lngRcv = dnsserv.ReceiveFrom(r, SocketFlags.None, rem_ep)

                ReDim Preserve r(lngRcv)

                str_r = Encoding.ASCII.GetString(r, 0, lngRcv)

                Console.WriteLine("Data from : " & CType(rem_ep, IPEndPoint).ToString)
                'Console.WriteLine(str_r)

                If mustLog Then File.AppendAllText(log, "Data from : " & CType(rem_ep, IPEndPoint).ToString & vbCrLf & _
                                                   str_r & vbCrLf & vbCrLf, Encoding.ASCII)

                host = str_r.Substring(12, str_r.IndexOf(Chr(0), 12) - 12)

                Dim requestedHost As String = ""
                Dim n As Integer = 0

                While n < host.Length
                    requestedHost &= host.Substring(n + 1, r(n + 12)) & "."
                    n += r(n + 12) + 1
                End While
                requestedHost = requestedHost.Substring(0, requestedHost.Length - 1)

                Console.WriteLine("Client requesting : " & requestedHost)

                If mustLog Then File.AppendAllText(log, "Client requesting : " & requestedHost & vbCrLf)

                ReDim rr(511)
                s = New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
                s.Connect(DEFAULT_DNS_SERVER, 53)
                s.Send(r, lngRcv, SocketFlags.None)
                lngSnd = s.Receive(rr, SocketFlags.None)

                ReDim Preserve rr(lngSnd)

                If mustLog Then File.AppendAllText(log, "Real DNS server's answer : " & vbCrLf & _
                                                   Encoding.ASCII.GetString(rr, 0, lngSnd) & vbCrLf & vbCrLf, Encoding.ASCII)

                'Checks if client is requesting 'gamestats2.gs.nintendowifi.net'
                'If str_r.Length > 43 AndAlso str_r.Substring(13, 30) = "gamestats2" & Chr(2) & "gs" & Chr(12) & "nintendowifi" & Chr(3) & "net" Then
                If requestedHost = "gamestats2.gs.nintendowifi.net" Then
                    'ReDim rr_fake(lngRcv + 15), rr(lngRcv + 15)

                    'Array.Copy(r, 0, rr_fake, 0, 2)
                    'rr_fake(2) = &H81
                    'rr_fake(3) = &H80
                    'Array.Copy(r, 4, rr_fake, 4, 2)
                    'Array.Copy(r, 4, rr_fake, 6, 2)
                    'rr_fake(8) = &H0
                    'rr_fake(9) = &H0
                    'rr_fake(10) = &H0
                    'rr_fake(11) = &H0
                    'Array.Copy(r, 12, rr_fake, 12, lngRcv - 12)
                    'rr_fake(lngRcv) = &HC0
                    'rr_fake(lngRcv + 1) = &HC
                    'rr_fake(lngRcv + 2) = &H0
                    'rr_fake(lngRcv + 3) = &H1
                    'rr_fake(lngRcv + 4) = &H0
                    'rr_fake(lngRcv + 5) = &H1
                    'rr_fake(lngRcv + 6) = &H0
                    'rr_fake(lngRcv + 7) = &H0
                    'rr_fake(lngRcv + 8) = &H0
                    'rr_fake(lngRcv + 9) = &H3C
                    'rr_fake(lngRcv + 10) = &H0
                    'rr_fake(lngRcv + 11) = &H4
                    'Array.Copy(fake_ip_byte, 0, rr_fake, lngRcv + 12, 4)
                    'rr = rr_fake
                    'str_rr = Encoding.ASCII.GetString(rr, 0, lngRcv + 16)

                    Array.Copy(fake_ip_byte, 0, rr, &H3C, 4)

                    Console.ForegroundColor = ConsoleColor.Green
                    Console.WriteLine("Spoofing : gamestats2.gs.nintendowifi.net -> " & fake_ip)
                    Console.ForegroundColor = defColor

                    If mustLog Then File.AppendAllText(log, "Spoofing : gamestats2.gs.nintendowifi.net -> " & fake_ip & vbCrLf)
                End If

                str_rr = Encoding.ASCII.GetString(rr, 0, lngSnd)

                dnsserv.SendTo(rr, rr.Length, SocketFlags.None, rem_ep)
                Console.WriteLine("Data sent to : " & CType(rem_ep, IPEndPoint).ToString)
                'Console.WriteLine(str_rr)

                If mustLog Then File.AppendAllText(log, "Data sent to : " & CType(rem_ep, IPEndPoint).ToString & vbCrLf & _
                                                   str_rr & vbCrLf, Encoding.ASCII)
                If mustLog Then File.AppendAllText(log, "------------------" & vbCrLf & vbCrLf)

                Console.WriteLine()
            Catch ex As Exception
                Console.ForegroundColor = ConsoleColor.Red
                Console.WriteLine("Error : " & ex.Message)
                Console.ForegroundColor = defColor
            End Try
        End While

        dnsserv.Close()
        s.Close()
    End Sub
End Module
